	org $FA0000
;//****************************************************************************
	include "defines.s"
	include "version.s"
;//****************************************************************************
	;// Bit 0 1 (24)-If set, the initialization code is performed before the initialization of the interrupt vectors and display memory.
	;// Bit 1 2 (25)-If set, cartridge initialization is performed before GEMDOS is initialized.
	;// Bit 2 4 (26)-Unused.
	;// Bit 3 8 (27)-If set, the initialization is performed just before a disk boot is performed. This may change in the ROMmed TOS.
	;// Bit 4 10 (28)-Unused.
	;// Bit 5 20 (29)-If set, the application is considered to be a desk accessory.
	;// Bit 6 40 (30)-If set, the ST will treat the application as a TOS program, and it is assumed that no AES calls will be performed.
	;// Bit 7 80 (31)-If set, the ST will treat the application as a "TOS-takes parameters" application. 

	;// cartridge start
	dc.l $abcdef42			; 0
	;//  dc.b $fa52235f
	dc.l 0					; 4 next
	dc.l start+$8000000	; 8 start code right before the content of the auto folder is executed
	dc.l prg				; c
	dc.w 0					; 10
	dc.w 0					; 12
	dc.l 0					; 14
	dc.b "dummy",0			; 18
	even

doColors		equ	0
;//****************************************************************************
	dc.w	firmwareVersion
	jmp		start
	jmp		loadbyBugaboo
	jmp		UDDIReadSector
;//****************************************************************************
;// do not remove this is a test pattern for build up
	dc.b	$1,$1
	dc.b	$2,$2
	dc.b	$4,$4
	dc.b	$8,$8
	dc.b	$10,$10
	dc.b	$20,$20
	dc.b	$40,$40
	dc.b	$80,$80

start:
	bsr		scanCookies
	bsr		saveVectors			;saves hdv and sets cartridge pos
	
	move.w	onoff,d0
	bne		normalstart

	bsr		UDGetVarRamPos
;	move.l 	a6,memtop		;top of ram

	;// check if ultraDev servers is running
	bsr		getZeroPageBackupPos
	move.l	a6,a0
;	move.l	#zeroPageBackup,a0
	moveq	#1,d0
	moveq	#1,d1
	bsr		UDDIReadSector
	tst		d0
	bmi.s	NoInitDrive
	bsr		initDrive
;	bsr		alloccaches_top
	bsr		alloccaches_malloc
;	move.l 	d0,memtop
	rts
NoInitDrive
	rts

normalstart:
	move	cartridgeUp,d0		;tell fpga the cartridge screen is up (saves a reset)

	movem.l	d0-a6,-(a7)
	bsr		UDGetVarRamPos
	move	#0,udBugabooLoadFlag(a6)
	pea		prg(pc)
	move.w	#$0026,-(a7)
	trap	#$0e
	adda.l	#6,a7
	movem.l	(a7)+,d0-a6
	clr.w	-(a7)
	trap	#1
	rts

loadbyBugaboo:
	cmp		#stateRunPrg,state
	beq		loadbyBugaboo

	bsr		UDGetVarRamPos
	move	#1,udBugabooLoadFlag(a6)
	jmp		loop
;//****************************************************************************
prg:
	cmp		#stateRunPrg,state
	beq		prg

	;copy the cartridge to 3f0000
	;if we run the code at cartridge rom position
	;the atari crashes if the firmware changes

	bsr		UDGetCartridgeRamPos
	move.l	a6,a1
	lea		startCartridge(pc),a0
;//	lea		cartridgePos,a1
	move	#((16384-(startCartridge-$fa0000))/16)-1,d0
.copyLoop:
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	dbf		d0,.copyLoop
	jmp		(a6)
;	jmp		cartridgePos

fontHdrId		equ	0
fontHdrData		equ	76
fontHdrWidth	equ	80
fontHdrHeight	equ	82
fontHdrNext		equ	84

startCartridge:
	;// search font
	sub.l	a2,a2
	clr.l	d2
	dc.w	$a000
							; line a fix http://www.atari-wiki.com/index.php/Line_A#init
	move.l  a2,d2			; old version? 
	bne     a2ok			; no, a2 points to array of Line-A routine addresses.
	lea     -4*15(a1),a2	; yes, a2 is untouched, so use a1 plus displacement (15 addresses).
a2ok:

fontLoop:
	move.l	(a1)+,a2
	beq.s	fontNotFound
	

	cmp		#8*32,fontHdrWidth(a2)
	bne		fontNext
	cmp		#8,fontHdrHeight(a2)
	bne		fontNext

	bsr		UDGetVarRamPos
	move.l	fontHdrData(a2),fontPosition(a6)
	
	bra		fontFound
fontNext:
	bra.s	fontLoop
fontNotFound:
fontFound:

	bsr		UDGetVarRamPos

	;// check if the zeropage magic is there
	;// this is saves during the first run
	;// the zero page and restores always
	;// the zero page because in case of unclean code run

	cmp.l	#udZeroPageMagic,udZeroPageMagicPos(a6)
	bne		.noZeroPageMagic
	lea		$8,a1
;	lea		zeroPageBackup,a0
	bsr		getZeroPageBackupPos
	move.l	a6,a0

	move	#(85)-1,d0
.copyzp1:
	movem.l	(a0)+,d1-d7/a2-a6		;7 5
	movem.l	d1-d7/a2-a6,(a1)
	lea		48(a1),a1
	dbf		d0,.copyzp1
	bra		.zeroPageRestored

.noZeroPageMagic
	lea		$8,a0
;	lea		zeroPageBackup,a1
	bsr		getZeroPageBackupPos
	move.l	a6,a1

	move	#(85)-1,d0
.copyzp2:
	movem.l	(a0)+,d1-d7/a2-a6		;7 5
	movem.l	d1-d7/a2-a6,(a1)
	lea		48(a1),a1
	dbf		d0,.copyzp2

	bsr		UDGetVarRamPos

	move.l	#udZeroPageMagic,udZeroPageMagicPos(a6)
.zeroPageRestored:

	move.l	phystop,d0
	sub.l	#$8000,d0
	
	;// setup screen
	move.w	#$0000,-(a7)
	move.l	d0,-(a7)
	move.l	d0,-(a7)
	move.w	#5,-(a7)
	trap	#14
	adda.l	#12,a7

	move	#$2700,sr
	bsr		getSsp
	lea		-sspLen(a6),a6
	bsr		getZeroPageBackupPos
	move.l 	a6,memtop		;top of ram

	bsr		UDGetVarRamPos
	move	#$222,$ffff8240.w
	move	#$fff,$ffff8242.w

	;// Setup terminal
;	bsr		UDFontReset
	moveq	#0,d0
	bsr		UDVidSetVideoMode
	moveq	#0,d0
	bsr		UDVidSetBGColor
	move	#' ',d0
	bsr		UDDbgScrClear
	move	#0,d0
	move	#0,d1
	move	#7,d2
	lea		vgaStartText(pc),a0
	bsr		UDDbgScrPrint

	lea		startText(pc),a0
	move	#0,d0
	move	#0,d1
	move	#1,d2
	bsr		printText
	move	#stateIdle,udStateCopy(a6)

	bsr		UDGetVarRamPos
	move.l	a6,d0
	lea		varBaseNumber(pc),a0
	bsr		writeHexLong

	bsr		getUsp
	move.l	a6,d0
	lea		uspTxt(pc),a0
	bsr		writeHexLong

	bsr		getSsp
	move.l	a6,d0
	lea		sspTxt(pc),a0
	bsr		writeHexLong


	lea		loadingAdrText(pc),a0
	move	#0,d0
	move	#6,d1
	bsr		printText

	bsr		printUploadCounter
	bsr		printStates

	move	readyFlag,d0	;tell the fpga the reset is done

loop:
	bsr		UDGetVarRamPos

	; 68k state machine
	move	state,d0
	cmp		#stateIdle,d0
	bne		.noIdle
	move	d0,udStateCopy(a6)
;	move	#$222,$ffff8240.w
.noIdle:
	cmp		#stateStartPrgSetup,d0
	beq		startPrgSetup
	cmp		#stateCopyBlock1,d0
	beq		copyBlock1
	cmp		#stateCopyBlock2,d0
	beq		copyBlock2
	cmp		#stateRunPrg,d0
	beq		runPrg
	bra		loop

;//****************************************************************************
startPrgSetup:
	cmp		udStateCopy(a6),d0	; check if the last block was the same state? if so
	beq		sendReady			; the fpga is not ready with receiving
	move	d0,udStateCopy(a6)

	;// calculate prg length and allocate memory
	if doColors == 1
	move	#$100,$ffff8240.w
	endc
	;alloc symbol table to bugaboo
	clr.l	udSymboltable(a6)

	lea     block1Pos,a0
	lea		64(a0),a0		;because of bugaboo commands
	tst.l	14(a0)
	beq		.noSymbols
	;alloc memory for symbols
	move.l 	14(a0),d0
	lsl.l	#2,d0			;because of bugaaboo need *4 len
	move.l	d0,-(a7)
	move.w  #$48,-(a7)
	trap    #1
	addq.l  #6,a7
	tst.l 	d0
	bne		.memOk2
	lea		outOfMemText(pc),a0
	bra		doError
.memOk2:
	bsr		UDGetVarRamPos
	move.l	d0,udSymboltable(a6)

.noSymbols:

	lea     block1Pos,a0
	lea		64(a0),a0		;because of bugaboo commands
	move.l  2(a0),d0        ;lenght text
	add.l   6(a0),d0        ;lenght data
	add.l   10(a0),d0       ;lenght bss
	add.l   14(a0),d0       ;lenght symboltable
	add.l   #$120,d0         ;add header & code page
	and.l   #$fffffffe,d0   ;lenght for plugin
	move.l	d0,udPrgLen(a6)
	add.l	#$30000,D0
	move.l  d0,-(a7)
	move.w  #$48,-(a7)
	trap    #1
	addq.l  #6,a7

	tst.l 	d0
	bne		.memOk
	bsr 	flushStates
	lea		outOfMemText(pc),a0
	bra		doError
.memOk:
	add.l	#$100,d0

	bsr		UDGetVarRamPos
	move.l	d0,udPrgAdrCopy(a6)

	sub.l	#hdrStartText-2,d0
	sub.l	#64,d0				;bugaboo commands
	move.l	d0,udBugaBooCmdListPos(a6)
	move.l  d0,udPrgAdr(a6)

	bra		copyBlock1Direct

;flush pending states in case of an error (e.g. outofmemory) so the next state is idle when user presses reset
flushStates
	move.w 	state,D0
	mulu 	d1,d1
	cmp.w 	#stateIdle,D0
	beq.s 	flushStatesOk
	move	readyFlag,d1	;send ready flag to fpga
	move	readyFlag,d1	;send ready flag to fpga
	move	readyFlag,d1	;send ready flag to fpga
	move	readyFlag,d1	;send ready flag to fpga
	bra.s 	flushStates 	
flushStatesOk
	rts

;//****************************************************************************
copyBlock1
	cmp		udStateCopy(a6),d0	; check if the last block was the same state? if so
	beq		sendReady		; the fpga is not ready with receiving
	move	d0,udStateCopy(a6)
copyBlock1Direct:
	if doColors == 1
	move	#$010,$ffff8240.w
	endc
	lea		block1Pos,a1
	bra		copyBlock

;//****************************************************************************
copyBlock2
	cmp		udStateCopy(a6),d0	; check if the last block was the same? if so
	beq		sendReady		; the fpga is not ready with receiving
	if doColors == 1
	move	#$001,$ffff8240.w
	endc
	move	d0,udStateCopy(a6)
	lea		block2Pos,a1
	bra		copyBlock

;//****************************************************************************
copyBlock
	; copies 8192 bytes to the destination
	move.l	udPrgAdr(a6),a0
	move	#(170)-1,d0
.copyBlockloop:
	movem.l	(a1)+,d1-d7/a2-a6		;7 5
	movem.l	d1-d7/a2-a6,(a0)
	lea		48(a0),a0
	dbf		d0,.copyBlockloop

	movem.l	(a1)+,d1-d7/a2		;7 5
	movem.l	d1-d7/a2,(a0)
	lea		32(a0),a0

	bsr		UDGetVarRamPos
	move.l	a0,udPrgAdr(a6)

	tst		udBugabooLoadFlag(a6)
	bne		.no13
	bsr		printUploadCounter
	bsr		printStates
.no13
	bra		loop

;//****************************************************************************
sendReady:
	move	readyFlag,d0	;send ready flag to fpga
	move	readyFlag,d0	;send ready flag to fpga
	move	readyFlag,d0	;send ready flag to fpga
	move	readyFlag,d0	;send ready flag to fpga
	if doColors == 1
	move	#$111,$ffff8240.w
	endc
	bra		loop

;//****************************************************************************
runPrg:
	move	cartridgeDown,d0		;tell fpga the cartridge screen is down (saves a reset)

	bsr		UDGetVarRamPos
	tst		udBugabooLoadFlag(a6)
	bne		.no12
	bsr		getSsp
	move.l	a6,a7
	bsr		UDGetVarRamPos
	bsr		printStates
.no12:


	move	readyFlag,d0	;send ready flag to fpga
;	move	readyFlag,d0	;send ready flag to fpga
;	move	readyFlag,d0	;send ready flag to fpga
;	move	readyFlag,d0	;send ready flag to fpga

	if doColors == 1
	move	#$745,$ffff8240.w
	endc
	;// build up code page
	move.l	udPrgAdrCopy(a6),a0
	sub.l	#$100,a0

	;a0 = code page
	;a1 = file header
	;a2 = pointer to the segments (moving)
	move.l	a0,p_lowtpa(a0)

	move.l	a0,a1
	add.l 	udPrgLen(a6),a1
	tst		udBugabooLoadFlag(a6)
	beq		.no123
	lea		$2000(a1),a1			;hm stack in bugaboo... not clear why i have to do this
.no123
	move.l	a1,p_hitpa(a0)

	;text segment
	move.l	udPrgAdrCopy(a6),a2
	move.l 	a2,p_tbase(a0)

	move.l	udPrgAdrCopy(a6),a1
	sub.l	#hdrStartText-2,a1
	move.l 	hdrSizeText(a1),p_tlen(a0)
	add.l	hdrSizeText(a1),a2

	;data segment
	move.l 	a2,p_dbase(a0)
	move.l 	hdrSizeData(a1),p_dlen(a0)
	add.l	hdrSizeData(a1),a2
	
	;bss seqment
	move.l	a2,p_bbase(a0)
	move.l 	hdrSizeBss(a1),p_blen(a0)

	lea		emptyEnvStr(pc),a3
	move.l	a3,p_env(a0)
	clr.l	p_cmdlin(a0)

	movea.l $04F2.w,a2      ;get Sysbase
	movea.l 8(a2),a4        ;get rom start
	move.l	$28(a4),a2 		;this is not present in TOS<1.02!

	tst		udBugabooLoadFlag(a6)
	bne		.no1
;/---------------------
;1MB TOS1.0 crash!!!	
;	move.l	(a2),p_parent(a0)  ;<====== this does not work with TOS1.0, not ROMSTART+$28 process pointer not present
;	move.l	a0,(a2)			;set act pd 
;1MB TOS1.0 crash!!!	
;\_____________________
	;START --------------------- TOS 1.0 workaround
	;check if this is TOS1.0 - unfortunately TOS1.0 does not know the first thing about cookies
	tst.l 	$5a0.w 				;cookie jar pointer
	bne.s 	.thisisnottos10 	;!=0 ==> TOS did set this, so we're definitively not on TOS 1.0
	cmp.w 	#$100,2(A4)
	beq.s 	.thisistos10
	;END ----------------------- TOS 1.0 workaround
.thisisnottos10:
	move.l	(a2),p_parent(a0)  ;<====== this does not work
	move.l	a0,(a2)			;set act pd 
.thisistos10:
.no1:
	tst		udBugabooLoadFlag(a6)
	bne		.no11
	bsr		getUsp
	move	#$0,sr
	move.l	a6,a7
	bsr		UDGetVarRamPos 
.no11:

	;// when start with bugaboo copy the symbols to the allocated memory
	tst		udBugabooLoadFlag(a6)
	beq		.no4
	tst.l	udSymboltable(a6)
	beq		.no4
	movem.l d0-a6,-(a7)
	
	move.l	udPrgAdrCopy(a6),a0
	sub.l	#hdrStartText-2,a0
	lea		(a0),a2
	move.l	udSymboltable(a6),a1
	move.l 	2(A0),D0        ;add text seg
    add.l   6(A0),D0        ;add data seg
	add.l	d0,a0			;sym pos
	move.l	14(a2),d0		;len
	move.l	d0,udSymboltablelen(a6)
	add.l	#hdrStartText-2,a0
	add.l 	#10,d0
	move.l	a0,a6
.copysym
	move.b	(a0)+,(a1)+
	sub.l	#1,d0
	bne		.copysym
	movem.l	(a7)+,d0-a6
.no4:
	;// relocate programm
	move.l	udPrgAdrCopy(a6),a0
	sub.l	#hdrStartText-2,a0
	bsr		relocate

	move	#stateIdle,udStateCopy(a6)
	move.l	udPrgAdrCopy(a6),a0
	sub.l	#$100,a0

	;clear bss
	move.l	p_bbase(a0),a1
	move.l	p_blen(a0),d0
	lsr.l	#4,d0
	tst.l	d0
	beq.s	.nobbs
	add.l	#4,d0
.clrbss:
	clr.l	(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	clr.l	(a1)+
	subq.l	#1,d0
	bne.s	.clrbss
.nobbs:
	move.l	a0,udMyBasePage(a6)

	tst		udBugabooLoadFlag(a6)
	bne.s	.no2
	move.l	a0,-(a7)	;put code page to stack
	clr.l	-(a7)		;clear something ;)

	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	moveq	#0,d3
	moveq	#0,d4
	moveq	#0,d5
	moveq	#0,d6
	moveq	#0,d7
	move.l	d0,a0
	move.l	d0,a1
	move.l	d0,a2
	move.l	d0,a3
	move.l	d0,a4
	move.l	d0,a5
;//	move.l	d0,a6
.no2:
	bsr		UDGetVarRamPos
	tst		udBugabooLoadFlag(a6)
	bne		.no3
	move.l	udPrgAdrCopy(a6),a6

	jmp		(a6)
	illegal
.no3:
	rts

;//****************************************************************************
doError:
	move	#0,d0
	move	#10,d1
	bsr		printText
.errorLoop:
	bra		.errorLoop

saveVectors:
	move	UDRegWriteToHdvBackup,d2

	move.l	hdv_bpb,d0
	bsr		UDDIWriteHdvLong

	move.l	hdv_rw,d0
	bsr		UDDIWriteHdvLong

	move.l	hdv_media,d0
	bsr		UDDIWriteHdvLong

	;// write cart ram position
	move.l	phystop,d0
	sub.l	#screenLen+cartridgeLen+ramLen,d0
	bsr		UDDIWriteHdvLong
	rts

getUsp:
	bsr		UDGetCartridgeRamPos
	rts

getSsp:
	bsr		UDGetCartridgeRamPos
	lea		-uspLen(a6),a6
	rts

getZeroPageBackupPos:
	bsr		UDGetCartridgeRamPos
;	lea		-(zeroPageBackupLen)(a6),a6
	lea		-(uspLen+sspLen+zeroPageBackupLen)(a6),a6
	rts

;//****************************************************************************
scanCookies:
	bsr		UDGetVarRamPos
	move	#0,cpuType(a6)
	move	#0,machineType(a6)

	move.l	$000005a0.w,d0
	beq.s	noCookies
	move.l 	d0,A0
	moveq	#31,d0
.scanCookieLoop:
	cmpi.l	#"_MCH",(a0)
	bne.s	.noMCHCookie
	move.w  4(a0),machineType(a6)
.noMCHCookie:
	cmpi.l	#"_CPU",(a0)
	bne.s	.noCPUCookie
	move.w  6(a0),machineType(a6)
.noCPUCookie:
	lea		8(a0),a0
	dbra	d0,.scanCookieLoop
noCookies:
	rts	

;//****************************************************************************

;//****************************************************************************
hex: dc.b "0123456789ABCDEF"
vgaStartText:
	dc.b "ultraDev VGA Debug Screen",10
	dc.b "-------------------------",0

startText:	dc.b "ultraDev     F"
;startTextFpgaVersion:
	dc.b 1
	dc.l UDFPGAVersion
	dc.b "."
	dc.b 1
	dc.l UDFPGAVersion+1
	dc.b " / "
	dc.b ((firmwareVersion&$f000)>>12)|$30
	dc.b ((firmwareVersion&$f00)>>8)|$30
	dc.b "."
	dc.b ((firmwareVersion&$f0)>>4)|$30
	dc.b ((firmwareVersion&$f))|$30
	dc.b " "

	dc.b "("
	dc.b ((firmwareYear&$f0)>>4)|$30
	dc.b ((firmwareYear&$f))|$30
	dc.b ((firmwareMonth&$f0)>>4)|$30
	dc.b ((firmwareMonth&$f))|$30
	dc.b ((firmwareDay&$f0)>>4)|$30
	dc.b ((firmwareDay&$f))|$30
	dc.b ((firmwareHour&$f0)>>4)|$30
	dc.b ((firmwareHour&$f))|$30
	dc.b ((firmwareMinute&$f0)>>4)|$30
	dc.b ((firmwareMinute&$f))|$30
	dc.b ")"
	dc.b 10
	dc.b "----------------------------------------",10,10

	dc.b "Waiting...",10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10
	dc.b "(c) 20"
	dc.b ((firmwareYear&$f0)>>4)|$30
	dc.b ((firmwareYear&$f))|$30
	dc.b " cream",0
	even
state68KText: dc.b "68k state: ",0

	;      0123456789abcdef
state68KTexts:	dc.b	"Idle           ",0
	dc.b	"StartPrgSetup  ",0
	dc.b	"CopyBlock1     ",0
	dc.b	"CopyBlock2     ",0
	dc.b	"RunPrg         ",0
	even

fpgaStateText: dc.b	"FPGA state:",10
				dc.b	1
				dc.l stateFPGA+1
				dc.b " " , 1
				dc.l stateFPGARet+1
				dc.b 0 
				
;//				"00 00",0
lenText:	dc.b 2
			dc.l uploadCount
			dc.b " ", 2
			dc.l byteCount
			dc.b 0
;//"0000 0000",0

loadingAdrText: dc.b	"MemStart: "
				dc.b	3
				dc.l	membot
				dc.b	"  MemEnd: "
				dc.b	3
				dc.l	memtop
				dc.b	10
				dc.b	"CartBase: "
				dc.b	3
				dc.l	UDCartridgeRamPos	
				dc.b	" VarBase: "
varBaseNumber: dc.b	"00000000",10
				 dc.b	"     USP: "
uspTxt:			dc.b	"00000000     SSP: "
sspTxt:			dc.b	"00000000 ",0


	even


outOfMemText: dc.b "Out of memory!...",0
	even

emptyEnvStr: dc.b	"PATH=",0
	dc.b	"A:\",0,0
	even

;//****************************************************************************
	include "screen.s"
;	include "disassemble.s"
;	include "font.s"
	include "relocate.s"
	include "drive.s"

	include "../68klib/UDDefines.s"
	include "../68klib/UDVideo.s"
	include "../68klib/UDDebugScreen.s"
;	include "../68klib/UDFont.s"
	include "../68klib/UDDriveImage.s"
	include "../68klib/UDCartridge.s"	


;//****************************************************************************
