****************************************************************************
* Project:	ultraDev
* Module:	UDCartridge
* Code:		ultra
* Created:	28.12.2019
* Notes:	Some service routine to handle the Cartridge like detecting,
*			version numbers and stuff...
* Modified:
* Changes:
*
* (c) 2019 cream
****************************************************************************

UDCartDetect:
;checks if the cartridge is available
;<-d0 0= not 1= it is
	moveq	#0,d0

	cmp.l	#$deadbeef,UDCartDetect1
	bne.s	.UDCartDetectDone
	moveq	#1,d0
.UDCartDetectDone:
	rts
****************************************************************************

UDCartGetFPGAVersion:
;returns the fpga firmware version
;<-do version number
	move	UDFPGAVersion,d0
	rts
****************************************************************************

UDCartGetJumpTable:
	bsr		UDCartDetect
	tst		d0
	beq.s	.UDCart68kVersionNoCart2
	lea		$fa0004,a0
.UDCartNextEntry:
	tst.l	(a0)
	beq.s	.UDCartFoundLastEntry
	move.l	(a0),a0
	bra.s	.UDCartNextEntry

.UDCartFoundLastEntry:
	lea		$14(a0),a0
	// skip name
.UDCartSkipNameLoop:
	tst.b	(a0)+
	beq.s	.UDCartNameEnd
	bra.s	.UDCartSkipNameLoop

.UDCartNameEnd:
	move	a0,d0
	btst	#0,d0
	beq.s	.UDCartIsEven
	lea		1(a0),a0
.UDCartIsEven:
	// skip version number
	lea		2(a0),a0
	rts
.UDCart68kVersionNoCart2:
	sub.l	a0,a0
	rts
****************************************************************************

UDCartGet68kVersion:
;returns the 68k firmware version
;<-do version number
	bsr		UDCartGetJumpTable
	cmp.l	#0,a0
	beq.s	.UDCart68kVersionNoCart
	// jump back to version number
	move	-2(a0),d0
	rts
	
.UDCart68kVersionNoCart:
	moveq	#0,d0
	rts

****************************************************************************
UDGetCartridgeRamPos:
	move.l	UDCartridgeRamPos,a6
	rts

****************************************************************************
UDGetVarRamPos:
	move.l	UDCartridgeRamPos,a6
	lea		$4000(a6),a6
	rts
